Checkmate changelog
===================

Version 0.4.0
-------------

Released on September 1, 2018.

 -  Became internally independent from the [range] library.
 -  Became to use GHC 8.4 internally.
 -  The officially distributed executable binaries for Linux became
    independent from [glibc] again, and statically linked to [musl] instead.

[range]: https://hackage.haskell.org/package/range
[musl]: https://www.musl-libc.org/


Version 0.3.3
-------------

Released on May 16, 2018.

 -  The officially distributed executable binaries for Linux became
    dependent on [glibc].

 -  Fixed a bug that it had failed to scan if any file in a change set is
    deleted.

[glibc]: https://www.gnu.org/software/libc/


Version 0.3.2
-------------

Released on November 4, 2017.

 -  Relicensed from GPLv3+ to [AGPLv3][]+ since [diff-parse][] library that
    Checkmate depends on has been licensed under AGPLv3.

 -  Fixed a bug that the diff parser had failed with a result of `endOfInput`
    when the input diff contains file renames.  It was a bug of [diff-parse][]
    library, and a [patch](https://github.com/mulby/diff-parse/pull/10) was
    needed to fix this.

[AGPLv3]: https://www.gnu.org/licenses/agpl-3.0.html
[diff-parse]: https://github.com/mulby/diff-parse


Version 0.3.1
-------------

Released on November 3, 2017.

 -  Fixed a bug that `checkmate github-travis` and `checkmate github-circle`
    commands were prone to reach rate limit of GitHub API due to unauthenticated
    request for getting metadata of the pull request.


Version 0.3.0
-------------

Released on October 21, 2017.

### Frontend

 -  Added a new filename *.check* besides *CHECK* as directory-level checklist
    file.

 -  `checkmate github` command became to leave no comment when there are
    nothing to `CHECK` corresponding to the given diff.  It also removes
    the existing comment previously left by Checkmate on the same pull request.

 -  Added `checkmate github-travis` and `checkmate github-circle` commands,
    shortcuts of `checkmate github` for Travis CI and Circle CI integration.
    It even doesn't need the result of `git diff`.

 -  `checkmate` and its subcommands became to terminate with a proper non-zero
    exit code and print messages to /dev/stderr instead of /dev/stdout when
    it fails to read diff.

### Internals

 -  Added `Checkmate.Publisher` and `Checkmate.Publisher.GitHub` module.


Version 0.2.1
-------------

Released on September 26, 2017.

 -  Fixed a parser bug which had scanned continuous inline comments of
    unmatched styles, e.g.:

        // CHECK This line is scanned.
        // This line also is scanned.
        -- This line had been scanned, but the parser is fixed
        -- so that it isn't scanned anymore.

 -  GitHub Flavored Markdown renderer (`checkmate gfm` and
    `Checkmate.Rendrer.toGFMarkdown`) became to ignore soft linebreaks to be
    consistent with CommonMark renderer.


Version 0.2.0
-------------

Released on September 25, 2017.

 -  Now `CHECK` comments in source codes can be multiline.  The following
    patterns are supported:

     -  ~~~ c
        /*
        CHECK Lorem ipsum dolor sit amet, per facilis reprimique ut,
        ei agam invenire mel.

        Tacimates nominati vix ut, ea iudicabit prodesset deseruisse duo.
        */
        ~~~

     -  ~~~ c
        // CHECK Lorem ipsum dolor sit amet, per facilis reprimique ut,
        // ei agam invenire mel.
        //
        // Tacimates nominati vix ut, ea iudicabit prodesset deseruisse duo.
        ~~~

 -  `CHECK` keywords with a colon (i.e. `CHECK:`) became matched.


Version 0.1.4
-------------

Released on September 21, 2017.

 -  Fixed a broken build of `checkmate` binary on the download page.
    It was crashed on Linux distros that glibc is unavailable.


Version 0.1.3
-------------

Released on September 20, 2017.

 -  Fixed a broken build of `checkmate` binary on the download page.


Version 0.1.2
-------------

Released on September 20, 2017.

 -  Fixed a broken build of `checkmate` binary on the download page.


Version 0.1.1
-------------

Released on September 20, 2017.

### Frontend

 -  Checklist texts generated by `checkmate commonmark`, `checkmate gfm`, and
    `checkmate github` became to have two levels of headings.  The top-level
    heading is still the title of the checklist as it has been, and the
    second-level heading is a corresponding file path of its following checks.

### Internals

 -  Added `Checkmate.Renderer` module.


Version 0.1.0
-------------

Initial release.  Released on September 20, 2017.
